//****************************************************************************
// @Module        Asynchronous / Synchronous Serial Interface (ASC)
// @Filename      ASC.H
// @Project       Teil1.dav
//----------------------------------------------------------------------------
// @Controller    Infineon C164CI-8E
//
// @Compiler      KEIL C166
//
// @Codegenerator DAvE 2-0-0
//
// @Description   This file contains all function prototypes and macros for
//                the Asynchronous / Synchronous Serial Interface.
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

//****************************************************************************
// @Prototypes of global functions
//****************************************************************************

void ASC_vInit(void);
void ASC_vSendData(uword Data);


// USER CODE BEGIN (ASCHeader,1)
void test(void);
void ClrScr( void );
void DoPrintZ(int iZnr, char *pBuf);
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

//****************************************************************************
// @Macro         ASC_vSetBaudrate(Value)
//
//----------------------------------------------------------------------------
// @Description   This macro loads the reload register of the baudrate
//                generator. The baudrate generator is loaded immediately
//                with the new value.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    13 bit value for the baudrate reload register
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

#define ASC_vSetBaudrate(Value) S0BG = Value



// USER CODE BEGIN (ASCHeader,2)

// USER CODE END


//***************************************************************************
// @Defines
//***************************************************************************


// USER CODE BEGIN (ASCHeader,4)

// USER CODE END


//****************************************************************************
// @Interrupt Vectors
//****************************************************************************

#define S0TINT    0x2A


// USER CODE BEGIN (ASCHeader,3)

// USER CODE END


