//****************************************************************************
// @Module        General Purpose Timer Unit 1
// @Filename      GT1.H
// @Project       Teil1.dav
//----------------------------------------------------------------------------
// @Controller    Infineon C164CI-8E
//
// @Compiler      KEIL C166
//
// @Codegenerator DAvE 2-0-0
//
// @Description   This file contains all function prototypes and macros for
//                the GPT1 unit.
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

//****************************************************************************
// @Prototypes of global functions
//****************************************************************************

void GT1_vInit(void);


// USER CODE BEGIN (Header,1)
int KeyDown(void);
char GetKey(void);
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

//****************************************************************************
// @Macro         GT1_vStartTmr(TimerNr)
//
//----------------------------------------------------------------------------
// @Description   This macro starts the selected GPT1 timer. The timer 
//                continues to count from where it had stopped.
//                The following definitions are available for TimerNr:
//                TIMER_2
//                TIMER_3
//                TIMER_4
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    the name of the timer to be started
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

#define GT1_vStartTmr(TimerNr)  GT1_vStart(TimerNr,R)
#define GT1_vStart(TimerNr,R) TimerNr##R = 1


//****************************************************************************
// @Macro         GT1_vStopTmr(TimerNr)
//
//----------------------------------------------------------------------------
// @Description   This macro stops the selected GPT1 timer. The contents of
//                the timer register remain unchanged.
//                The following definitions are available for TimerNr:
//                TIMER_2
//                TIMER_3
//                TIMER_4
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    the name of the timer to be stopped
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

#define GT1_vStopTmr(TimerNr)  GT1_vStop(TimerNr,R)
#define GT1_vStop(TimerNr,R) TimerNr##R = 0                     


//****************************************************************************
// @Macro         GT1_vClearTmr(TimerNr)
//
//----------------------------------------------------------------------------
// @Description   This macro stops the selected GPT1 timer and sets the timer
//                register to 0.
//                The following definitions are available for TimerNr:
//                TIMER_2
//                TIMER_3
//                TIMER_4
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    the name of the timer to be cleared
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

#define GT1_vClearTmr(TimerNr) GT1_vClrTmr(TimerNr,R)
#define GT1_vClrTmr(TimerNr,R) TimerNr##R = 0; TimerNr = 0x0000 


//****************************************************************************
// @Macro         GT1_vLoadTmr(TimerNr,Value)
//
//----------------------------------------------------------------------------
// @Description   This macro loads the selected GPT1 timer with the forwarded
//                value. The timer is not stopped. The access of the CPU to
//                the registers of the timers is of higher priority than a
//                timer increment, a reload or a capture event.
//                The following definitions are available for TimerNr:
//                TIMER_2
//                TIMER_3
//                TIMER_4
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    the name of the timer to be loaded
// @Parameters    16-bit value to be loaded
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

#define GT1_vLoadTmr(TimerNr,Value) TimerNr = Value



// USER CODE BEGIN (Header,2)

// USER CODE END


//***************************************************************************
// @Defines
//***************************************************************************

#define TIMER_2 T2
#define TIMER_3 T3
#define TIMER_4 T4


// USER CODE BEGIN (Header,3)

// USER CODE END


//***************************************************************************
// @Interrupt vectors
//***************************************************************************

#define T2INT   0x22


// USER CODE BEGIN (Header,4)

// USER CODE END


