//****************************************************************************
// @Module        Main
// @Filename      MAIN.C
// @Project       Teil1.dav
//----------------------------------------------------------------------------
// @Controller    Infineon C164CI-8E
//
// @Compiler      KEIL C166
//
// @Codegenerator DAvE 2-0-0
//
// @Description   This file contains the Project initialization function.
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

/*
******************************************************************************
@Note




******************************************************************************
*/

//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (Main,0)
#include "GT1.h"
#include <string.h>
// USER CODE END


//***************************************************************************
// @Global Variables
//***************************************************************************

// USER CODE BEGIN (Main,3)

// USER CODE END

//****************************************************************************
// @Function      void Project_Init(void)
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    none
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

void Project_Init(void)
{

  // USER CODE BEGIN (Project_Init,0)

  // USER CODE END

  /// the following initialization is made by the compiler EDE when you
  /// import the DAvE project

  /// --- initialization of the SYSCON Register ---
  ///- 256 words system stack
  ///- the internal ROM area is mapped to segment 1
  ///- the segmentation is enabled (CSP is saved/restored during interrupt entry/exit)
  ///- the internal ROM is disabled: accesses to the ROM area use the external bus
  ///- the pin #BHE (byte high enable) is enabled
  ///- the system clock output is disabled
  ///- the pin #WR acts as #WRL and pin #BHE acts as #WRH
  ///- the on-chip X-Peripherals are enabled and can be accessed
  ///- pin #RSTIN is an input only
  ///- the on-chip oscillator watchdog is disabled
  ///- latched CS mode; CS signals are latch internally


  /// --- initialization of the BUSCON 0-4 and ADRRSEL Registers 1-4 ---

  /// ---------- external bus 0 is enabled ----------
  ///- 16-bit multiplexed bus
  ///- memory cycle time control: 15 waitstates
  ///- read/write delay control: activate signal 1 TCL after falling edge of ALE  
  ///- chip select mode: address chip select 
  ///- memory tristate control: 1 waitstate
  ///- ALE lengthening control: lengthened ALE signal


  // initializes the IO ports
  IO_vInit();

  // initializes the Asynchronous/Synchronous Serial Interface (ASC)
  ASC_vInit();

  // initializes the General Purpose Timer Unit 1 (GPT1)
  GT1_vInit();

  // USER CODE BEGIN (Project_Init,1)

  // USER CODE END

  /// globally enable interrupts
  IEN = 1;
}


//****************************************************************************
// @Function      void main(void)
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    none
//
//----------------------------------------------------------------------------
// @Date          08.04.2013 10:49:17
//
//****************************************************************************

void main(void)
{
  // USER CODE BEGIN (Main,1)
	int pin=0;
  // USER CODE END

  Project_Init();

  // USER CODE BEGIN (Main,2)

	GT1_vStartTmr(TIMER_2);

	ClrScr();
 
  while(1)
  {
  	if(KeyDown())
	{
	 	switch(GetKey())
		{

		 	case '1': pin = IO_bReadPin(P1L_4);
				if( pin )
					IO_vResetPin(P1L_4);
				else
					IO_vSetPin(P1L_4);
				DoPrintZ(1, "Taster 1.");
				break;
			case '2': pin = IO_bReadPin(P1L_5);
				if( pin )
					IO_vResetPin(P1L_5);
				else
					IO_vSetPin(P1L_5);
				DoPrintZ(2, "Taster 2.");
				break;
			case '3': pin = IO_bReadPin(P1L_6);
				if( pin )
					IO_vResetPin(P1L_6);
				else
					IO_vSetPin(P1L_6);
				DoPrintZ(3, "Taster 3.");
				break;
			case '4': pin = IO_bReadPin(P1L_7);
				if( pin )
					IO_vResetPin(P1L_7);
				else
					IO_vSetPin(P1L_7);
				DoPrintZ(4, "Taster 4.");
				break;
			default :
				break;
		}
	}
  }

  // USER CODE END
}

